
struct pll_limits
{
	ggi_uint		fref;	/* reference frequency		*/
	ggi_ratio	a;	/* generator dependent factor	*/
	ggi_range	fvco;	/* VCO frequency limits		*/
	ggi_range	p;	/* post-VCO divider range	*/
	ggi_range	mul;	/* multiplier value range	*/
	ggi_range	div;	/* divider value range		*/
};

struct pll_state
{
	ggi_uint	f;		/* produced frequency		*/
	ggi_uint	fvco;		/* VCO frequency		*/
	ggi_uint	p;		/* post-VCO divider		*/
	ggi_uint	mul;		/* multiplier value		*/
	ggi_uint	div;		/* divider value 		*/
};


static ggi_uint pll_command(struct pll_state *state, struct kgi_mode *mode);
static void pll_set(struct kgi_display *, ggi_uint);
static ggi_sint pll_best_state(ggi_uint f, enum kgi_tm_cmd cmd,
	struct pll_state *s, const struct pll_limits *pll);
